SystemOrganization addCategory: #ConfigurationOfWebBrowser!

Object subclass: #ConfigurationOfWebBrowser
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfWebBrowser'!

!ConfigurationOfWebBrowser commentStamp: 'TorstenBergmann 4/13/2016 08:47' prior: 0!
General and platform independent WebBrowser access for Pharo 5.0 onwards based on UFFI!

!ConfigurationOfWebBrowser class methodsFor: 'development support' stamp: 'TorstenBergmann 4/13/2016 08:45'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>! !

!ConfigurationOfWebBrowser class methodsFor: 'private' stamp: 'TorstenBergmann 4/13/2016 08:45'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #'ConfigurationOf'
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #'ConfigurationOf' ifAbsent: aBlock ].! !

!ConfigurationOfWebBrowser class methodsFor: 'catalog' stamp: 'TorstenBergmann 4/13/2016 08:48'!
catalogChangeLog
	"Returns a paragraph describing the most important changes in the configuration class."
	^ ''! !

!ConfigurationOfWebBrowser class methodsFor: 'catalog' stamp: 'TorstenBergmann 4/13/2016 08:49'!
catalogContactInfo
	"Returns a paragraph describing contact information such as email, mailing lists and website."
	^ 'You can get in contact with the author on the Pharo mailinglist (http://lists.pharo.org)'! !

!ConfigurationOfWebBrowser class methodsFor: 'catalog' stamp: 'TorstenBergmann 4/13/2016 09:22'!
catalogDescription
	"Returns a paragraph describing the project"
	^ 'General and platform independent WebBrowser access for Pharo 4.0 onwards based on NativeBoost, for Pharo 5.0 onwards based on UFFI'! !

!ConfigurationOfWebBrowser class methodsFor: 'catalog' stamp: 'TorstenBergmann 4/13/2016 08:49'!
catalogKeyClassesAndExample
	"Returns a paragraph or more describing the key classes of your project. You can use Pillar/Pier syntax to layout out the text i.e., ==Code== and - for bullet."
	^ 'Check the example on the class side of class ==WebBrowser==.'! !

!ConfigurationOfWebBrowser class methodsFor: 'catalog' stamp: 'TorstenBergmann 4/13/2016 08:50'!
catalogKeywords
	"Returns an array of symbols"
	^ #(webbrowser utility url platform web internet) ! !

!ConfigurationOfWebBrowser class methodsFor: 'private' stamp: 'TorstenBergmann 4/13/2016 08:45'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfWebBrowser class methodsFor: 'private' stamp: 'TorstenBergmann 4/13/2016 08:45'!
ensureMetacelloBaseConfiguration
  Smalltalk
    at: #'ConfigurationOf'
    ifAbsent: [ 
      | repository version |
      repository := MCHttpRepository
        location: 'http://smalltalkhub.com/mc/dkh/metacello/main'
        user: ''
        password: ''.
      repository
        versionReaderForFileNamed: 'Metacello-Base-dkh.107'
        do: [ :reader | 
          version := reader version.
          version load.
          version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfWebBrowser class methodsFor: 'metacello tool support' stamp: 'TorstenBergmann 4/13/2016 08:45'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfWebBrowser class methodsFor: 'loading' stamp: 'TorstenBergmann 4/13/2016 08:45'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfWebBrowser class methodsFor: 'loading' stamp: 'TorstenBergmann 4/13/2016 08:45'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfWebBrowser class methodsFor: 'loading' stamp: 'TorstenBergmann 4/13/2016 08:45'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfWebBrowser class methodsFor: 'accessing' stamp: 'TorstenBergmann 4/13/2016 08:45'!
project

	^self new project! !

!ConfigurationOfWebBrowser class methodsFor: 'development support' stamp: 'TorstenBergmann 4/13/2016 08:45'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfWebBrowser methodsFor: 'baselines' stamp: 'TorstenBergmann 4/13/2016 08:46'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/TorstenBergmann/WebBrowser/main/'.
		spec package: #'WebBrowser-Core'.
		spec 
			group: 'Core' with: #(#'WebBrowser-Core' );
			group: 'all' with: #('Core' );
			group: 'default' with: #('all' ). ].
! !

!ConfigurationOfWebBrowser methodsFor: 'baselines' stamp: 'TorstenBergmann 4/13/2016 09:47'!
baseline02: spec
	<version: '0.2-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/TorstenBergmann/WebBrowser/main/'.
		spec package: #'WebBrowser-Core'.
		spec 
			group: 'Core' with: #(#'WebBrowser-Core' );
			group: 'all' with: #('Core' );
			group: 'default' with: #('all' ). ].
! !

!ConfigurationOfWebBrowser methodsFor: 'baselines' stamp: 'TorstenBergmann 4/13/2016 09:48'!
baseline03: spec
	<version: '0.3-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/TorstenBergmann/WebBrowser/main/'.
		spec package: #'WebBrowser-Core'.
		spec 
			group: 'Core' with: #(#'WebBrowser-Core' );
			group: 'all' with: #('Core' );
			group: 'default' with: #('all' ). ].
! !

!ConfigurationOfWebBrowser methodsFor: 'accessing' stamp: 'TorstenBergmann 4/13/2016 08:45'!
customProjectAttributes
    "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes "

    ^ #()! !

!ConfigurationOfWebBrowser methodsFor: 'symbolic versions' stamp: 'TorstenBergmann 4/13/2016 09:48'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.3-baseline'.
! !

!ConfigurationOfWebBrowser methodsFor: 'accessing' stamp: 'TorstenBergmann 4/13/2016 08:45'!
project
    ^ project
        ifNil: [ 
            "Bootstrap Metacello if it is not already loaded"
            self class ensureMetacello.
            project := MetacelloMCProject new projectAttributes: self customProjectAttributes.	"Create the Metacello project"
            (Smalltalk at: #'MetacelloVersionConstructor') on: self project: project.	"Construct the project"
            project loadType: #'linear'.	"change to #atomic if desired"
            project ]! !

!ConfigurationOfWebBrowser methodsFor: 'symbolic versions' stamp: 'TorstenBergmann 4/13/2016 09:48'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'pharo4.x' version: '0.1.0'.
	spec for: #'common' version: '0.2.0'.
! !

!ConfigurationOfWebBrowser methodsFor: 'versions' stamp: 'TorstenBergmann 4/13/2016 09:22'!
version010: spec
	<version: '0.1.0' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'Version 0.1.0 for Pharo 4 based on NB'.
		spec author: 'TorstenBergmann'.
		spec timestamp: '4/13/2016 08:46'.
		spec package: #'WebBrowser-Core' with: 'WebBrowser-Core-TorstenBergmann.1'. ].
! !

!ConfigurationOfWebBrowser methodsFor: 'versions' stamp: 'TorstenBergmann 4/13/2016 09:47'!
version020: spec
	<version: '0.2.0' imports: #('0.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'Version 0.2.0 for Pharo 5 based on UFFI'.
		spec author: 'TorstenBergmann'.
		spec timestamp: '4/13/2016 08:46'.
		spec package: #'WebBrowser-Core' with: 'WebBrowser-Core-TorstenBergmann.5'. ].
! !
